...

Text file src/make.bash

Documentation: Index

     1#!/usr/bin/env bash
     2# Copyright 2009 The Go Authors. All rights reserved.
     3# Use of this source code is governed by a BSD-style
     4# license that can be found in the LICENSE file.
     5
     6# See golang.org/s/go15bootstrap for an overview of the build process.
     7
     8# Environment variables that control make.bash:
     9#
    10# GOROOT_FINAL: The expected final Go root, baked into binaries.
    11# The default is the location of the Go tree during the build.
    12#
    13# GOHOSTARCH: The architecture for host tools (compilers and
    14# binaries).  Binaries of this type must be executable on the current
    15# system, so the only common reason to set this is to set
    16# GOHOSTARCH=386 on an amd64 machine.
    17#
    18# GOARCH: The target architecture for installed packages and tools.
    19#
    20# GOOS: The target operating system for installed packages and tools.
    21#
    22# GO_GCFLAGS: Additional go tool compile arguments to use when
    23# building the packages and commands.
    24#
    25# GO_LDFLAGS: Additional go tool link arguments to use when
    26# building the commands.
    27#
    28# CGO_ENABLED: Controls cgo usage during the build. Set it to 1
    29# to include all cgo related files, .c and .go file with "cgo"
    30# build directive, in the build. Set it to 0 to ignore them.
    31#
    32# GO_EXTLINK_ENABLED: Set to 1 to invoke the host linker when building
    33# packages that use cgo.  Set to 0 to do all linking internally.  This
    34# controls the default behavior of the linker's -linkmode option.  The
    35# default value depends on the system.
    36#
    37# GO_LDSO: Sets the default dynamic linker/loader (ld.so) to be used
    38# by the internal linker.
    39#
    40# CC: Command line to run to compile C code for GOHOSTARCH.
    41# Default is "gcc". Also supported: "clang".
    42#
    43# CC_FOR_TARGET: Command line to run to compile C code for GOARCH.
    44# This is used by cgo. Default is CC.
    45#
    46# CC_FOR_${GOOS}_${GOARCH}: Command line to run to compile C code for specified ${GOOS} and ${GOARCH}.
    47# (for example, CC_FOR_linux_arm)
    48# If this is not set, the build will use CC_FOR_TARGET if appropriate, or CC.
    49#
    50# CXX_FOR_TARGET: Command line to run to compile C++ code for GOARCH.
    51# This is used by cgo. Default is CXX, or, if that is not set,
    52# "g++" or "clang++".
    53#
    54# CXX_FOR_${GOOS}_${GOARCH}: Command line to run to compile C++ code for specified ${GOOS} and ${GOARCH}.
    55# (for example, CXX_FOR_linux_arm)
    56# If this is not set, the build will use CXX_FOR_TARGET if appropriate, or CXX.
    57#
    58# FC: Command line to run to compile Fortran code for GOARCH.
    59# This is used by cgo. Default is "gfortran".
    60#
    61# PKG_CONFIG: Path to pkg-config tool. Default is "pkg-config".
    62#
    63# GO_DISTFLAGS: extra flags to provide to "dist bootstrap".
    64# (Or just pass them to the make.bash command line.)
    65#
    66# GOBUILDTIMELOGFILE: If set, make.bash and all.bash write
    67# timing information to this file. Useful for profiling where the
    68# time goes when these scripts run.
    69#
    70# GOROOT_BOOTSTRAP: A working Go tree >= Go 1.20.6 for bootstrap.
    71# If $GOROOT_BOOTSTRAP/bin/go is missing, $(go env GOROOT) is
    72# tried for all "go" in $PATH. By default, one of $HOME/go1.20.6,
    73# $HOME/sdk/go1.20.6, or $HOME/go1.4, whichever exists, in that order.
    74# We still check $HOME/go1.4 to allow for build scripts that still hard-code
    75# that name even though they put newer Go toolchains there.
    76
    77bootgo=1.20.6
    78
    79set -e
    80
    81if [[ ! -f run.bash ]]; then
    82	echo 'make.bash must be run from $GOROOT/src' 1>&2
    83	exit 1
    84fi
    85
    86if [[ "$GOBUILDTIMELOGFILE" != "" ]]; then
    87	echo $(LC_TIME=C date) start make.bash >"$GOBUILDTIMELOGFILE"
    88fi
    89
    90# Test for Windows.
    91case "$(uname)" in
    92*MINGW* | *WIN32* | *CYGWIN*)
    93	echo 'ERROR: Do not use make.bash to build on Windows.'
    94	echo 'Use make.bat instead.'
    95	echo
    96	exit 1
    97	;;
    98esac
    99
   100# Test for bad ld.
   101if ld --version 2>&1 | grep 'gold.* 2\.20' >/dev/null; then
   102	echo 'ERROR: Your system has gold 2.20 installed.'
   103	echo 'This version is shipped by Ubuntu even though'
   104	echo 'it is known not to work on Ubuntu.'
   105	echo 'Binaries built with this linker are likely to fail in mysterious ways.'
   106	echo
   107	echo 'Run sudo apt-get remove binutils-gold.'
   108	echo
   109	exit 1
   110fi
   111
   112# Test for bad SELinux.
   113# On Fedora 16 the selinux filesystem is mounted at /sys/fs/selinux,
   114# so loop through the possible selinux mount points.
   115for se_mount in /selinux /sys/fs/selinux
   116do
   117	if [[ -d $se_mount && -f $se_mount/booleans/allow_execstack && -x /usr/sbin/selinuxenabled ]] && /usr/sbin/selinuxenabled; then
   118		if ! cat $se_mount/booleans/allow_execstack | grep -c '^1 1$' >> /dev/null ; then
   119			echo "WARNING: the default SELinux policy on, at least, Fedora 12 breaks "
   120			echo "Go. You can enable the features that Go needs via the following "
   121			echo "command (as root):"
   122			echo "  # setsebool -P allow_execstack 1"
   123			echo
   124			echo "Note that this affects your system globally! "
   125			echo
   126			echo "The build will continue in five seconds in case we "
   127			echo "misdiagnosed the issue..."
   128
   129			sleep 5
   130		fi
   131	fi
   132done
   133
   134# Test for debian/kFreeBSD.
   135# cmd/dist will detect kFreeBSD as freebsd/$GOARCH, but we need to
   136# disable cgo manually.
   137if [[ "$(uname -s)" == "GNU/kFreeBSD" ]]; then
   138	export CGO_ENABLED=0
   139fi
   140
   141# Clean old generated file that will cause problems in the build.
   142rm -f ./runtime/runtime_defs.go
   143
   144# Finally!  Run the build.
   145
   146verbose=false
   147vflag=""
   148if [[ "$1" == "-v" ]]; then
   149	verbose=true
   150	vflag=-v
   151	shift
   152fi
   153
   154goroot_bootstrap_set=${GOROOT_BOOTSTRAP+"true"}
   155if [[ -z "$GOROOT_BOOTSTRAP" ]]; then
   156	GOROOT_BOOTSTRAP="$HOME/go1.4"
   157	for d in sdk/go$bootgo go$bootgo; do
   158		if [[ -d "$HOME/$d" ]]; then
   159			GOROOT_BOOTSTRAP="$HOME/$d"
   160		fi
   161	done
   162fi
   163export GOROOT_BOOTSTRAP
   164
   165nogoenv() {
   166	GO111MODULE=off GOENV=off GOOS= GOARCH= GOEXPERIMENT= GOFLAGS= "$@"
   167}
   168
   169export GOROOT="$(cd .. && pwd)"
   170IFS=$'\n'; for go_exe in $(type -ap go); do
   171	if [[ ! -x "$GOROOT_BOOTSTRAP/bin/go" ]]; then
   172		goroot=$(GOROOT= nogoenv "$go_exe" env GOROOT)
   173		if [[ "$goroot" != "$GOROOT" ]]; then
   174			if [[ "$goroot_bootstrap_set" == "true" ]]; then
   175				printf 'WARNING: %s does not exist, found %s from env\n' "$GOROOT_BOOTSTRAP/bin/go" "$go_exe" >&2
   176				printf 'WARNING: set %s as GOROOT_BOOTSTRAP\n' "$goroot" >&2
   177			fi
   178			GOROOT_BOOTSTRAP="$goroot"
   179		fi
   180	fi
   181done; unset IFS
   182if [[ ! -x "$GOROOT_BOOTSTRAP/bin/go" ]]; then
   183	echo "ERROR: Cannot find $GOROOT_BOOTSTRAP/bin/go." >&2
   184	echo "Set \$GOROOT_BOOTSTRAP to a working Go tree >= Go $bootgo." >&2
   185	exit 1
   186fi
   187# Get the exact bootstrap toolchain version to help with debugging.
   188# We clear GOOS and GOARCH to avoid an ominous but harmless warning if
   189# the bootstrap doesn't support them.
   190GOROOT_BOOTSTRAP_VERSION=$(nogoenv "$GOROOT_BOOTSTRAP/bin/go" version | sed 's/go version //')
   191echo "Building Go cmd/dist using $GOROOT_BOOTSTRAP. ($GOROOT_BOOTSTRAP_VERSION)"
   192if $verbose; then
   193	echo cmd/dist
   194fi
   195if [[ "$GOROOT_BOOTSTRAP" == "$GOROOT" ]]; then
   196	echo "ERROR: \$GOROOT_BOOTSTRAP must not be set to \$GOROOT" >&2
   197	echo "Set \$GOROOT_BOOTSTRAP to a working Go tree >= Go $bootgo." >&2
   198	exit 1
   199fi
   200rm -f cmd/dist/dist
   201GOROOT="$GOROOT_BOOTSTRAP" nogoenv "$GOROOT_BOOTSTRAP/bin/go" build -o cmd/dist/dist ./cmd/dist
   202
   203# -e doesn't propagate out of eval, so check success by hand.
   204eval $(./cmd/dist/dist env -p || echo FAIL=true)
   205if [[ "$FAIL" == true ]]; then
   206	exit 1
   207fi
   208
   209if $verbose; then
   210	echo
   211fi
   212
   213if [[ "$1" == "--dist-tool" ]]; then
   214	# Stop after building dist tool.
   215	mkdir -p "$GOTOOLDIR"
   216	if [[ "$2" != "" ]]; then
   217		cp cmd/dist/dist "$2"
   218	fi
   219	mv cmd/dist/dist "$GOTOOLDIR"/dist
   220	exit 0
   221fi
   222
   223# Run dist bootstrap to complete make.bash.
   224# Bootstrap installs a proper cmd/dist, built with the new toolchain.
   225# Throw ours, built with the bootstrap toolchain, away after bootstrap.
   226./cmd/dist/dist bootstrap -a $vflag $GO_DISTFLAGS "$@"
   227rm -f ./cmd/dist/dist
   228
   229# DO NOT ADD ANY NEW CODE HERE.
   230# The bootstrap+rm above are the final step of make.bash.
   231# If something must be added, add it to cmd/dist's cmdbootstrap,
   232# to avoid needing three copies in three different shell languages
   233# (make.bash, make.bat, make.rc).

View as plain text